/*
 * Beangle, Agile Java/Scala Development Scaffold and Toolkit
 *
 * Copyright (c) 2005-2013, Beangle Software.
 *
 * Beangle is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Beangle is distributed in the hope that it will be useful.
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Beangle.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.beangle.commons.text.seq

import scala.collection.mutable

/**
 * <p>
 * MultiLevelSeqGenerator class.
 * </p>
 *
 * @author chaostone
 * @version $Id: $
 */
class MultiLevelSeqGenerator {

  private val patterns = new mutable.HashMap[Int, SeqPattern]

  /**
   * getPattern.
   */
  def getPattern(level: Int): SeqPattern = patterns(level)

  /**
   * next.
   */
  def next(level: Int): String = getPattern(level).next()

  /**
   * add.
   */
  def add(style: SeqPattern) {
    style.generator = this
    patterns.put(style.level, style)
  }

  /**
   * reset.
   */
  def reset(level: Int) {
    getPattern(level).reset()
  }
}
